/*
 * s_walk.h
 */

#ifdef _WIN32
#define STEP_SIZE	50
#include <windows.h>
#else
#define STEP_SIZE	0
#endif
#include <stdio.h>
#include <stdlib.h>
#ifndef __APPLE__
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#else
#include <OpenGL/gl.h>
#include <GLUT/glut.h>
#endif

#include "GLMetaseq.h"	// f[_

/*
 *
 */

#define S_WALK_PROGRAM_SIZE 10000

static char S_walk_program [ S_WALK_PROGRAM_SIZE ];
static int S_walk_program_end = 0;

/*
 *
 */

#define	S_WALK_MOVE	'm'
#define	S_WALK_JUMP	'j'
#define	S_WALK_TURN	't'
#define	S_WALK_WAIT	'w'

/*
 *
 */

#define	S_WALK_MODEL_WAIT	0
#define	S_WALK_MODEL_WALK	1
#define	S_WALK_MODEL_RUN	2
#define	S_WALK_MODEL_SIZE	3

static char *model_name[S_WALK_MODEL_SIZE] = {
  "wait",
  "walk",
  "run"
};

/*
 *
 */

// O[oϐ
int g_mouseX = 0;	// }EXXW
int g_mouseY = 0;	// }EXYW
int g_rotX = 0;		// X̉]
int g_rotY = 0;		// Ỷ]
double g_posX = 0.0;		// Ẍʒu
double g_posY = -100.0;		// Ÿʒu
double g_posZ = -1000.0;		// Z̈ʒu

#define FRAME_SIZE	61

MQO_MODEL g_mqoModel[S_WALK_MODEL_SIZE][FRAME_SIZE];	// MQOf

int model_type = S_WALK_MODEL_WALK;
int model_number = 0;
int frame_number = FRAME_SIZE;
int step_size = STEP_SIZE;

// vg^Cv錾
void mySetLight(void);
void Draw(void);
void Reshape (int w, int h);
void Keyboard(unsigned char key, int x, int y);
void Mouse(int button, int state, int x, int y);
void Motion(int x, int y);

// ̐ݒs֐
void mySetLight(void)
{
	GLfloat light_diffuse[]  = { 0.9, 0.9, 0.9, 1.0 };	// gUˌ
	GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };	// ʔˌ
	GLfloat light_ambient[]  = { 0.3, 0.3, 0.3, 0.1 };	// 
	GLfloat light_position[] = { 0.0, 0.0, 0.0, 1.0 };	// ʒuƎ

	// ̐ݒ
	glLightfv( GL_LIGHT0, GL_DIFFUSE,  light_diffuse );	 // gUˌ̐ݒ
	glLightfv( GL_LIGHT0, GL_SPECULAR, light_specular ); // ʔˌ̐ݒ
	glLightfv( GL_LIGHT0, GL_AMBIENT,  light_ambient );	 // ̐ݒ
	glLightfv( GL_LIGHT0, GL_POSITION, light_position ); // ʒuƎނ̐ݒ

	glShadeModel( GL_SMOOTH );	// VF[fBO̎ނ̐ݒ
	glEnable( GL_LIGHT0 );		// ̗L
}


// `֐
void Draw(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// 
	glClearColor(0.f, 0.f, 0.2f, 1.0);					// wiF
	glMatrixMode(GL_MODELVIEW);

	glEnable( GL_DEPTH_TEST );		// Bʏ̓Kp
	mySetLight();					// ̐ݒ
	glEnable( GL_LIGHTING );		// ON

	glPushMatrix();
		glTranslatef(g_posX, g_posY, g_posZ);	// sړ
		glRotatef( g_rotX, 1, 0, 0 );		// X]
		glRotatef( g_rotY, 0, 1, 0 );		// Y]
		mqoCallModel(g_mqoModel[model_type][model_number]);			// MQOf̃R[
	glPopMatrix();

	glDisable( GL_LIGHTING );
	glDisable( GL_DEPTH_TEST );

	glutSwapBuffers();
}


// EBhEό`ɌĂ΂֐
void Reshape (int w, int h)
{
	double	znear = 10;
	double	fovy = 50;
	double	zfar = 10000;

	// r[|[gݒ
	glViewport(0, 0, w, h);

	// ˉeݒ
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(fovy, (double)w/h, znear, zfar);
}


// L[Cxg֐
void Keyboard(unsigned char key, int x, int y)
{
	switch (key) {
		case 'q':
		case 'Q':
		case 0x1b:
			exit(0);	// îƏI֐Ă΂j
		default:
			break;
	}
}


// }EXCxg֐
void Mouse(int button, int state, int x, int y)
{

  switch ( state ) {
  case GLUT_DOWN:
	g_mouseX = x;
	g_mouseY = y;
	break;
  case GLUT_UP:
	break;
  }

}

// }EXhbȌ֐
void Motion(int x, int y)
{
	int xd, yd;

	// }EXړʂ̎Zo
	xd = x - g_mouseX;
	yd = y - g_mouseY;
	
	// ]ʂ̐ݒ
	g_rotX += yd;
	g_rotY += xd;

	// }EXW̍XV
	g_mouseX = x;
	g_mouseY = y;
}


// I֐
void Quit(void)
{
  int m;
  int f;

	for ( m = 0; m < S_WALK_MODEL_SIZE; m++ ) {
		for ( f = 0; f < FRAME_SIZE; f++ ) {
			mqoDeleteModel( g_mqoModel[m][f] );	// f̍폜
		}
	}

	mqoCleanup();					// GLMetaseq̏I
}

int step = STEP_SIZE;

  static int dx[] = {  0,  1,  1,  1,  0, -1, -1, -1 };
  static int dy[] = {  1,  1,  0, -1, -1, -1,  0,  1 };
  static int px = 0;
  static int py = 0;
  static int dr = 0;
  static int pc = -1;

void Idle(void) {
	int i;

	if ( step < step_size ) {
		step++;
	} else {
		step = 0;
		if ( frame_number < FRAME_SIZE - 1 ) {
			switch ( S_walk_program [ pc ] ) {
			case S_WALK_MOVE:
			case S_WALK_JUMP:
				g_posX += dx[dr] * 8;
				g_posZ += dy[dr] * 8;
				frame_number++;
				model_number = frame_number;
				break;
			case S_WALK_TURN:
				g_rotY = dr * 45.0 - 45.0 * ( FRAME_SIZE - frame_number ) / FRAME_SIZE;
				frame_number += 6;
				model_number = 0;
				break;
			case S_WALK_WAIT:
				frame_number++;
				model_number = frame_number;
#ifdef _WIN32
//			Sleep( 4 );
#endif
				break;
			}
		} else {
			frame_number = 0;
			model_number = frame_number;
			if ( pc < S_walk_program_end - 1 ) {
				switch ( S_walk_program [ ++pc ] ) {
				case S_WALK_MOVE:
					model_type = S_WALK_MODEL_WALK;
					step_size = STEP_SIZE;
					break;
				case S_WALK_JUMP:
					model_type = S_WALK_MODEL_RUN;
					step_size = STEP_SIZE;
					break;
				case S_WALK_TURN:
					model_type = S_WALK_MODEL_WAIT;
					g_rotY = dr * 45;
					dr = ( dr + 1 ) % 8;
					step_size = STEP_SIZE;
					break;
				case S_WALK_WAIT:
					model_type = S_WALK_MODEL_WAIT;
					step_size = STEP_SIZE * 20;
					break;
				}
			}
		}
	}

	/*
	printf ( "program[%d] = %c ", pc, S_walk_program [ pc ] );
	printf ( "model_number = %d model_type = %d ", model_number, model_type );
	printf ( "g_rotY=%d, dr = %d, g_posX = %f, g_posZ = %f\n", g_rotY, dr, g_posX, g_posZ );
	*/

	Draw();
}

/*
 *
 */

extern void s_walk_move( void );
extern void s_walk_jump( void );
extern void s_walk_turn( void );
extern void s_walk_wait( void );

/*
 *
 */

static	int run_flag = 0;

static void S_walk_atexit() {
  char *argv[] = { "Walk", NULL };
  int argc = 1;
  int m;
  int f;
  char fname [ 100 ];

	if ( run_flag > 0 ) {
		_exit ( 0 );
	}
	run_flag = 1;

	glutInit(&argc,argv);						// OpenGL
	glutInitWindowPosition(100, 50);				// EBhE̕\ʒu
	glutInitWindowSize(640, 480);					// EBhẼTCY
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);	// fBXvCݒ
	glutCreateWindow("Miku Walker");				// EBhE̐

	// f\鏀
	mqoInit();							// GLMetaseq̏

//	printf ( "Loading Models... " );
	for ( m = 0; m < S_WALK_MODEL_SIZE; m++ ) {
		for ( f = 0; f < FRAME_SIZE; f++ ) {
			sprintf ( fname, "model/%s_%05d.mqo", model_name [ m ], f );
			printf ( "Loading Models... %s", fname );
			g_mqoModel[m][f] = mqoCreateModel(fname,0.5);		// f̃[h
			printf ( "\r                                                                    \r");
		}
	}
	printf ( " Done.\n" );

	// R[obN֐̐ݒ
	glutDisplayFunc(Draw);			// `揈֐̐ݒ
	glutIdleFunc(Idle);			// ACh̏֐̐ݒ
	glutReshapeFunc(Reshape);		// EBhEό`̏s֐̐ݒ
	glutKeyboardFunc(Keyboard);		// L[͎̏֐̐ݒ
	glutMouseFunc(Mouse);			// }EX͎̏֐̐ݒ
	glutMotionFunc(Motion);			// }EXhbȌ֐̐ݒ

#ifdef _WIN32
#else
	sleep(1);
#endif

	s_walk_wait();

	// Cxg҂̖[vɓ

	glutMainLoop();
}

/*
 *
 */

static S_walk_init_flag = 0;

static void S_walk_init(void) {

  if ( S_walk_init_flag == 0 ) {
	S_walk_init_flag = 1;
	// Main 
	atexit ( S_walk_atexit );
	// I֐̐ݒ
	//	atexit(Quit);
  }
}

/*
 *
 */

static void S_walk_add_program ( char code ) {

  if ( S_walk_program_end < S_WALK_PROGRAM_SIZE ) {
	S_walk_program [ S_walk_program_end++ ] = code;
  } else {
	fprintf ( stderr, "Too many codes\n" );
  }
}

/*
 *
 */

void s_walk_move() {
  S_walk_init();
  S_walk_add_program ( S_WALK_MOVE );
}

void s_walk_jump() {
  S_walk_init();
  S_walk_add_program ( S_WALK_JUMP );
}

void s_walk_turn() {
  S_walk_init();
  S_walk_add_program ( S_WALK_TURN );
}

void s_walk_wait() {
  S_walk_init();
  S_walk_add_program ( S_WALK_WAIT );
}

/*
 *
 */


